#!/bin/sh

UPDATE_FILE=update.tar.gz
RC_EXTRA=/flash/qvidium/rc.extra
ZIXI_DIR=/disk/zixi
RC_ZIXI=$ZIXI_DIR/rc.zixi

# Stop zixi_feeder
if pidof zixi_feeder > /dev/null ; then
    if [ -f $ZIXI_DIR/bin/zixi_stop ] ; then
        sh $ZIXI_DIR/bin/zixi_stop
    else
        killall zixi_feeder
    fi
    sleep 1
fi

# Clean directories
rm -rf $ZIXI_DIR
sync

# Install new software
tar xf /tmp/$UPDATE_FILE -C /disk

# Update rc.extra
LINE="[ -f $RC_ZIXI ] && $RC_ZIXI"
if [ ! -f $RC_EXTRA ] ; then
    echo $LINE > $RC_EXTRA
elif ! grep $RC_ZIXI $RC_EXTRA > /dev/null ; then
    echo $LINE >> $RC_EXTRA
fi
$RC_ZIXI

# Cleanup files
rm -f $UPDATE_FILE script.sh install.sh
sync

exit 0
