#!/bin/sh

# Copyright (C) 2004-2021 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

DIR=/flash/qvidium/encoder
get_new_profile_name() {
    NUM=0
    PROFILE=profile$NUM
    FILE=$DIR/$PROFILE
    while [ -f $FILE ] ; do
        NUM=`expr $NUM + 1`
        PROFILE=profile$NUM
        FILE=$DIR/$PROFILE
    done
}

cache_profile_names() {
    NAMES=
    for FILE in $(ls $DIR)
     do
     if [ "$FILE"x != x ] ; then
              if [ "$FILE" != defaults ] ; then
                  NAME=
                  . $DIR/$FILE
                  [ "$NAME"x != x ] && NAMES="$NAME,$NAMES"
              fi
        fi
    done
}

PROFILE=
EDIT_FORM=1
if [ "$QUERY_STRING" != "" ] ; then
    eval `./cgiparse "$QUERY_STRING"`
    OLDPROFILE=$PROFILE
    if [ "$state" = "Save" ] ; then
        EDIT_FORM=0
    elif [ "$state" = "edit" ] ; then
        EDIT_FORM=0
    elif [ "$state" = "SaveAs" ] ; then
        EDIT_FORM=0
        get_new_profile_name
    elif [ "$save" != "" ] ; then
        EDIT_FORM=0
    elif [ "$save_as" != "" ] ; then
        EDIT_FORM=0
        get_new_profile_name
    elif [ "$edit" != "Edit" ] ; then
        EDIT_FORM=0
        get_new_profile_name
    elif [ "$edit" = "Edit" ] ; then
        EDIT_FORM=1
    elif [ "$edit" = "" ] ; then
        EDIT_FORM=0
    fi
fi
[ "$PROFILE" = "" ] && PROFILE=profile
PROFILE_BASE=$PROFILE
PROFILE=/flash/qvidium/encoder/$PROFILE_BASE

if [ $EDIT_FORM = 1 ] ; then

    HAS_ZIXI=0
    HAS_RTSP=0
    HAS_RTMP=0
    HAS_MSS=0
    HAS_HLS=0
    HAS_QVSERVER=0
    HAS_ARQ=0
    HAS_TCP=0
    HAS_FEC=0
    HAS_BOND=0
    HAS_QVSTREAM=0

    // Get list of profile names as $NAMES
    cache_profile_names
    
    [ -f /disk/zixi/bin/ZixiTx -a -f /disk/zixi/lib/libzixiFeeder.so ] && HAS_ZIXI=1
    [ -f /disk/qvstream/libqvstream.so.1.0 ] && HAS_QVSTREAM=1
    [ -f /flash/qvidium/rtsp.conf ] && HAS_RTSP=1
    [ -f /flash/qvidium/qvserver.conf ] && HAS_QVSERVER=1
    [ -f /flash/qvidium/bond.conf ] && HAS_BOND=1
    /qvidium/tx_proxy -C /flash/qvidium/tx_proxy1.lic > /dev/null 2>&1
    [ $? = 0 ] && HAS_ARQ=1
    RTMP_STR='optional'
    if [ -f /disk/evostream/rc.evostream_push ] ; then
        if [ ! -f /disk/evostream/ffmpeg ] ; then
          HAS_RTMP=1
        else
          /qvidium/LicenseId -C /flash/qvidium/ffmpeg.lic FFMpeg > /dev/null 2>&1
          if [ $? -le 1 ] ; then
            RTMP_STR='required'
            HAS_RTMP=1
            HAS_MSS=1
            . /qvidium/find_dir.sh
            find_dir
            if [ "$MOUNT_DIR" != "" ] ; then
              HAS_HLS=1
              RTMP_STR='required for RTMP amd MSS'
            fi
          fi
        fi
    fi
    [ -f /flash/qvidium/prompeg.conf ] && HAS_FEC=1
    LIBQVSTREAM=/disk/qvstream/libqvstream.so.1.0
    if [ -f $LIBQVSTREAM ] ; then
        strings $LIBQVSTREAM | grep 'Encoder TCP output' > /dev/null
        [ $? = 0 ] && HAS_TCP=1
    fi

    HAS_SDI=true
    HAS_ASI=false
    HAS_HDMI=false
    [ -f /flash/qvidium/inputs.conf ] && . /flash/qvidium/inputs.conf
    [ "$HAS_SDI" = "" ] && HAS_SDI=true
    if [ "$HAS_SDI" = true ] ; then
        if [ "$QVENC_BOARD" = true ] ; then
            /qvidium/LicenseId SDI > /dev/null 2>&1
            [ $? -gt 1 ] && HAS_SDI=false
        else
            HAS_ASI=true
            HAS_HDMI=true
        fi
    fi

    ALT_DEST_PORT=1234
    ALT_DEST_IPADDR=
    CLOSED_CAPTION=none
    BOND_PORTS=false
    LAN1_PERCENT=50
    STREAM_TYPE=Transport
    STREAM_MODE="Constant Bit Rate (CBR)"
    ENC_TYPE="None"
    STREAM_PASSWORD=
    TS_BITRATE=8000000
    SD_SDI_BITRATE=0
    MPEG4_PROFILE=auto
    MPEG4_LEVEL=auto
    NUM_B_FRAMES=auto
    NUM_P_FRAMES=auto
    PROGRAM=1
    DTS_DELAY_FROM_PCR=200
    FILE_SIZE=Unlimited
    FILE_NAME=clip
    FILE_OVERWRITE=No
    REMUX=Live
    VIDEO_PID=256
    AUDIO_PID=272
    AUDIO_PID2=288
    PCR_PID=$VIDEO_PID
    PMT_PID=48
    AUDIO_LANG_DESC1=eng
    AUDIO_LANG_DESC2=spa
    AUDIO_FIXED_PES=No
    AVIN_6DB_ATTN=false
    AUDIO_BITRATE=160000
    AUDIO_SAMPLE_RATE=48000
    AUDIO_ENCODING="MPEG1 Layer2"
    VIDEO_ENCODING=H264
    VIDEO_INPUT=SDI
    VIDEO_FILTER=On
    ENCODER_ACTION=Restart
    SD_PROGRESSIVE=No
    SHARPNESS=default
    VIDEO_OUTPUT=Auto
    VIDEO_SD_RES=Full
    RESYNC_SDI=No
    RESYNC_HDMI=No
    DYNAMIC_BITRATE=No
    ANALOG_HDVIDEO=No
    AUDIO_CHANNELS=2
    AUDIO_VIDEO=Both
    FRAME_RATE=Full
    VIDEO_ASPECT=4x3
    OUTPUT=Network
    TRANSPORT=ARQ
    IPADDR_OR_HOSTNAME=
    UDP_PORT=
    NUM_TS_PKTS_PER_IP_PKT=7
    SEQ_0XFFFF_HACK=no
    USE_PACING=1
    USE_CEILING=0
    FEC_COLUMNS=10
    FEC_ROWS=10
    FEC_TYPE="Row + Column"
    UNI_TTL=128
    M_TTL=64
    TOS=0
    ARQ_TX_BUFS=4096
    ARQ_PORT=10000
    DO_METADATA=0
    METADATA_PORT=4096
    DO_SDP=0
    SDP_NAME="QVidium Codec"
	ZIXI_LOGLEVEL="Warning"
	ADAPTATION=0

    OLD_PROFILE=$PROFILE
    [ -f $PROFILE ] && . $PROFILE
    PROFILE=$OLD_PROFILE
    [ "$NAME" = "" ] && NAME="Not Set"
    OLDNAME=$NAME

    if [ $HAS_SDI = false ] ; then
        [ "$VIDEO_INPUT" = HDMI ] && VIDEO_INPUT=Composite
        [ "$VIDEO_INPUT" = SDI ] && VIDEO_INPUT=Composite
        [ "$VIDEO_INPUT" = "" ] && VIDEO_INPUT=Composite
    fi

    if [ "$TS_BITRATE" = 0 ] ; then
        case "$AUDIO_VIDEO" in
            *ideo*) audio_bitrate=0 ;;
                 *) audio_bitrate=$AUDIO_BITRATE ;;
        esac
        if [ "$VIDEO_BITRATE" != "" ] ; then
            TS_BITRATE=$(($VIDEO_BITRATE + $audio_bitrate + 40000))
            TS_BITRATE=$(($TS_BITRATE + $TS_BITRATE/10))
        fi
    fi
    if [ "$TS_BITRATE" = "" ] ; then
        TS_BITRATE=8000000
        [ $HAS_SDI = false ] && TS_BITRATE=2240000
    fi
    [ $TS_BITRATE -lt 224000 ] && TS_BITRATE=224000

    [ "$ALT_DEST_PORT" = "" ] && ALT_DEST_PORT=1234
    if [ "$UDP_PORT" = "" ] ; then
        UDP_PORT=10000
        [ $HAS_RTMP = true -o $HAS_MSS = true ] && UDP_PORT=""
        [ $HAS_HLS = true ] && UDP_PORT="playlist"
    fi
    [ "$ARQ_PORT" = "" ] && ARQ_PORT=10000
    [ "$NUM_TS_PKTS_PER_IP_PKT" = "" ] && NUM_TS_PKTS_PER_IP_PKT=7
    [ "$UNI_TTL" = "" ] && UNI_TTL=128
    [ "$M_TTL" = "" ] && M_TTL=64
    [ "$METADATA_PORT" = "" ] && METADATA_PORT=4096
    [ "$OUTPUT" = "" ] && OUTPUT=Network
    [ "$VIDEO_PID" = "" ] && VIDEO_PID=256
    [ "$AUDIO_PID" = "" ] && AUDIO_PID=272
    [ "$AUDIO_PID2" = "" ] && AUDIO_PID2=288
    [ "$PCR_PID" = "" ] && PCR_PID=$VIDEO_PID
    [ "$PMT_PID" = "" ] && PMT_PID=48
    [ "$NUM_P_FRAMES" = "" ] && NUM_P_FRAMES=auto
    [ "$NUM_B_FRAMES" = "" ] && NUM_B_FRAMES=auto
    [ "$LAN1_PERCENT" = "" ] && LAN1_PERCENT=50
    [ "$ARQ_TX_BUFS" = "" ] && ARQ_TX_BUFS=4096
    [ "$PROGRAM" = "" ] && PROGRAM=1
    [ "$REMUX" = "" ] && REMUX=Live
    [ "$SD_PROGRESSIVE" = "" ] && SD_PROGRESSIVE=No
    [ "$DTS_DELAY_FROM_PCR" = "" ] && DTS_DELAY_FROM_PCR=200
    [ "$FEC_COLUMNS" = "" ] && FEC_COLUMNS=10
    [ "$FEC_ROWS" = "" ] && FEC_ROWS=10
    [ "$FEC_TYPE" = "" ] && FEC_TYPE="Row + Column"
    [ "$AUDIO_LANG_DESC1" = "" ] && AUDIO_LANG_DESC1=eng
    [ "$AUDIO_LANG_DESC2" = "" ] && AUDIO_LANG_DESC2=spa
    [ "$TOS" = "" ] && TOS=0
    [ "$AUDIO_FIXED_PES" = "" ] && AUDIO_FIXED_PES=No
    [ "$LATENCY" = "" ] && LATENCY=1000
	[ "$ZIXI_LOGLEVEL" = "" ] && ZIXI_LOGLEVEL=Warning
	[ "$ADAPTATION" = "" ] && ADAPTATION=0

    AUDIO_FIXED_PES_YES_Selected=
    AUDIO_FIXED_PES_NO_Selected=
    case "$AUDIO_FIXED_PES" in
        Yes) AUDIO_FIXED_PES_YES_Selected=selected ;;
          *) AUDIO_FIXED_PES_NO_Selected=selected ;;
    esac

    FEC_CO_Selected=
    FEC_RC_Selected=
    case "$FEC_TYPE" in
        *Only) FEC_CO_Selected=selected ;;
            *) FEC_RC_Selected=selected ;;
    esac

    CBR_Selected=
    CAPPED_VBR_Selected=
    LOW_DELAY_VBR_Selected=
    case "$STREAM_MODE" in
        Capped*) CAPPED_VBR_Selected=selected ;;
           Low*) LOW_DELAY_VBR_Selected=selected ;;
              *) CBR_Selected=selected ;;
    esac
    
    NOENC_Selected=
    AES128_Selected=
    AES192_Selected=
    AES256_Selected=
    CHACHA20_Selected=
    case "$ENC_TYPE" in
        AES-128) AES128_Selected=selected ;;
        AES-192) AES192_Selected=selected ;;
        AES-256) AES256_Selected=selected ;;
        ChaCha20) CHACHA20_Selected=selected ;;
        *) NOENC_Selected=selected ;;
    esac
    
    LOGM_Selected=
    LOG1_Selected=
    LOG2_Selected=
    LOG3_Selected=
    LOG4_Selected=
    LOG5_Selected=
    case "$ZIXI_LOGLEVEL" in
        Off)   		LOGM_Selected=selected ;;
        Debug) 		LOG1_Selected=selected ;;
        Info)  		LOG2_Selected=selected ;;
        Warning)	LOG3_Selected=selected ;;
        Error) 		LOG4_Selected=selected ;;
        Critical) 	LOG5_Selected=selected ;;
        *) LOG3_Selected=selected ;;
    esac
	
	ADAPT_Checked=
	[ $ADAPTATION = "1" ] && ADAPT_Checked="checked"

    TS_PKTS_1_Selected=
    TS_PKTS_2_Selected=
    TS_PKTS_3_Selected=
    TS_PKTS_4_Selected=
    TS_PKTS_5_Selected=
    TS_PKTS_6_Selected=
    TS_PKTS_7_Selected=
    case "$NUM_TS_PKTS_PER_IP_PKT" in
        1) TS_PKTS_1_Selected=selected ;;
        2) TS_PKTS_2_Selected=selected ;;
        3) TS_PKTS_3_Selected=selected ;;
        4) TS_PKTS_4_Selected=selected ;;
        5) TS_PKTS_5_Selected=selected ;;
        6) TS_PKTS_6_Selected=selected ;;
        *) TS_PKTS_7_Selected=selected ;;
    esac

    [ "$FILE_NAME" = "" ] && FILE_NAME=clip

    FM0_CHECKED=
    FM1_CHECKED=
    case "$FILE_OVERWRITE" in
        Yes) FM1_CHECKED=checked ;;
        *) FM0_CHECKED=checked ;;
    esac

    FILE_SIZE_50M_Selected=
    FILE_SIZE_100M_Selected=
    FILE_SIZE_250M_Selected=
    FILE_SIZE_500M_Selected=
    FILE_SIZE_1G_Selected=
    FILE_SIZE_2G_Selected=
    FILE_SIZE_3G_Selected=
    FILE_SIZE_4G_Selected=
    FILE_SIZE_6G_Selected=
    FILE_SIZE_8G_Selected=
    FILE_SIZE_0_Selected=
    case "$FILE_SIZE" in
         50M) FILE_SIZE_50M_Selected=selected ;;
        100M) FILE_SIZE_100M_Selected=selected ;;
        250M) FILE_SIZE_250M_Selected=selected ;;
        500M) FILE_SIZE_500M_Selected=selected ;;
          1G) FILE_SIZE_1G_Selected=selected ;;
          2G) FILE_SIZE_2G_Selected=selected ;;
          3G) FILE_SIZE_3G_Selected=selected ;;
          4G) FILE_SIZE_4G_Selected=selected ;;
          6G) FILE_SIZE_6G _Selected=selected ;;
          8G) FILE_SIZE_8G_Selected=selected ;;
           *) FILE_SIZE_0_Selected=selected ;;
    esac

    EncAction_Reboot_Selected=
    EncAction_Restart_Selected=
    case "$ENCODER_ACTION" in
        Reboot) EncAction_Reboot_Selected=selected ;;
        *) EncAction_Restart_Selected=selected ;;
    esac

    REMUX=Live
    REMUX_LIVE_Selected=
    REMUX_PVR_Selected=
    case "$REMUX" in
        Live) REMUX_LIVE_Selected=selected ;;
           *) REMUX_PVR_Selected=selected ;;
    esac

    AVIN_6DB_ATTN_ON_Selected=
    AVIN_6DB_ATTN_OFF_Selected=
    case "$AVIN_6DB_ATTN" in
        Yes) AVIN_6DB_ATTN_ON_Selected=selected ;;
        *) AVIN_6DB_ATTN_OFF_Selected=selected ;;
    esac

    SD_P_ON_Selected=
    SD_P_OFF_Selected=
    case "$SD_PROGRESSIVE" in
        Yes) SD_P_ON_Selected=selected ;;
        *) SD_P_OFF_Selected=selected ;;
    esac

    ARQ_TX_BUFS_1024_Selected=
    ARQ_TX_BUFS_2048_Selected=
    ARQ_TX_BUFS_4096_Selected=
    case "$ARQ_TX_BUFS" in
        2048) ARQ_TX_BUFS_2048_Selected=selected ;;
        4096) ARQ_TX_BUFS_4096_Selected=selected ;;
        *) ARQ_TX_BUFS_1024_Selected=selected ;;
    esac

    BOND_TRUE_CHECKED=
    BOND_FALSE_CHECKED=
    case "$BOND_PORTS" in
        true) BOND_TRUE_CHECKED=checked ;;
        *) BOND_FALSE_CHECKED=checked ;;
    esac

    PACING0_CHECKED=
    PACING1_CHECKED=
    case "$USE_PACING" in
        1) PACING1_CHECKED=checked ;;
        *) PACING0_CHECKED=checked ;;
    esac

    CEILING0_CHECKED=
    CEILING1_CHECKED=
    case "$USE_CEILING" in
        1) CEILING1_CHECKED=checked ;;
        *) CEILING0_CHECKED=checked ;;
    esac

    P_FRAME_0_Selected=
    P_FRAME_1_Selected=
    P_FRAME_2_Selected=
    P_FRAME_3_Selected=
    P_FRAME_4_Selected=
    P_FRAME_5_Selected=
    P_FRAME_9_Selected=
    P_FRAME_14_Selected=
    P_FRAME_19_Selected=
    P_FRAME_29_Selected=
    P_FRAME_A_Selected=
    case "$NUM_P_FRAMES" in
        0) P_FRAME_0_Selected=selected ;;
        1) P_FRAME_1_Selected=selected ;;
        2) P_FRAME_2_Selected=selected ;;
        3) P_FRAME_3_Selected=selected ;;
        4) P_FRAME_4_Selected=selected ;;
        5) P_FRAME_5_Selected=selected ;;
        9) P_FRAME_9_Selected=selected ;;
        14) P_FRAME_14_Selected=selected ;;
        19) P_FRAME_19_Selected=selected ;;
        29) P_FRAME_29_Selected=selected ;;
        *) P_FRAME_A_Selected=selected ;;
    esac

    B_FRAME_0_Selected=
    B_FRAME_1_Selected=
    B_FRAME_2_Selected=
    B_FRAME_A_Selected=
    case "$NUM_B_FRAMES" in
        0) B_FRAME_0_Selected=selected ;;
        1) B_FRAME_1_Selected=selected ;;
        2) B_FRAME_2_Selected=selected ;;
        *) B_FRAME_A_Selected=selected ;;
    esac

    PROFILE_B_Selected=
    PROFILE_M_Selected=
    PROFILE_H_Selected=
    PROFILE_A_Selected=
    case "$MPEG4_PROFILE" in
        Base) PROFILE_B_Selected=selected ;;
        Main) PROFILE_M_Selected=selected ;;
        High) PROFILE_H_Selected=selected ;;
           *) PROFILE_A_Selected=selected ;;
    esac

    LEVEL_12_Selected=
    LEVEL_20_Selected=
    LEVEL_21_Selected=
    LEVEL_22_Selected=
    LEVEL_30_Selected=
    LEVEL_31_Selected=
    LEVEL_32_Selected=
    LEVEL_40_Selected=
    LEVEL_41_Selected=
    LEVEL_A_Selected=
    case "$MPEG4_LEVEL" in
        1.2) LEVEL_12_Selected=selected ;;
        2.0) LEVEL_20_Selected=selected ;;
        2.1) LEVEL_21_Selected=selected ;;
        2.2) LEVEL_22_Selected=selected ;;
        3.0) LEVEL_30_Selected=selected ;;
        3.1) LEVEL_31_Selected=selected ;;
        3.2) LEVEL_32_Selected=selected ;;
        4.0) LEVEL_40_Selected=selected ;;
        4.1) LEVEL_41_Selected=selected ;;
          *) LEVEL_A_Selected=selected ;;
    esac

    VID_default_Selected=
    VID_D1_Selected=
    VID_QCIF_Selected=
    VID_CIF_Selected=
    VID_VGA_Selected=
    VID_QVGA_Selected=
    VID_HALF_D1_Selected=
    VID_HALF_HD_Selected=
    VID_3_4_HD_Selected=
    case "$VIDEO_SD_RES" in
            #QCIF) VID_QCIF_Selected=selected ;;
            QCIF) VID_CIF_Selected=selected ;;
         352x240) VID_CIF_Selected=selected ;;
         352x288) VID_CIF_Selected=selected ;;
             CIF) VID_CIF_Selected=selected ;;
            Half) VID_HALF_D1_Selected=selected ;;
              D1) VID_D1_Selected=selected ;;
             VGA) VID_VGA_Selected=selected ;;
            QVGA) VID_QVGA_Selected=selected ;;
        "1/2 HD") VID_HALF_HD_Selected=selected
                  if [ $HAS_SDI = false ] ; then
                      VID_HALF_HD_Selected=
                      VID_default_Selected=selected
                  fi
                  ;;
        "3/4 HD") VID_3_4_HD_Selected=selected
                  if [ $HAS_SDI = false ] ; then
                      VID_3_4_HD_Selected=
                      VID_default_Selected=selected
                  fi
                  ;;
               *) VID_default_Selected=selected ;;
    esac

    FORMAT_1080p60_Selected=
    FORMAT_1080p50_Selected=
    FORMAT_1080i60_Selected=
    FORMAT_1080i50_Selected=
    FORMAT_720p60_Selected=
    FORMAT_720p50_Selected=
    FORMAT_480p60_Selected=
    FORMAT_576p50_Selected=
    FORMAT_480i60_Selected=
    FORMAT_576i50_Selected=
    FORMAT_352i60_Selected=
    FORMAT_352i50_Selected=
    FORMAT_240p30_Selected=
    FORMAT_288p25_Selected=
    FORMAT_AUTO_Selected=
    case "$VIDEO_OUTPUT" in
        1920x1080@60p) FORMAT_1080p60_Selected=selected ;;
        1920x1080@50p) FORMAT_1080p50_Selected=selected ;;
        1920x1080@60i) FORMAT_1080i60_Selected=selected ;;
        1920x1080@50i) FORMAT_1080i50_Selected=selected ;;
         1280x720@60p) FORMAT_720p60_Selected=selected ;;
         1280x720@50p) FORMAT_720p50_Selected=selected ;;
          720x480@60p) FORMAT_480p60_Selected=selected ;;
          720x576@50p) FORMAT_576p50_Selected=selected ;;
          720x480@60i) FORMAT_480i60_Selected=selected ;;
          720x576@50i) FORMAT_576i50_Selected=selected ;;
          352x480@60i) FORMAT_352i60_Selected=selected ;;
          352x576@50i) FORMAT_352i50_Selected=selected ;;
          352x240@30p) FORMAT_240p30_Selected=selected ;;
          352x288@25p) FORMAT_288p25_Selected=selected ;;
                    *) FORMAT_AUTO_Selected=selected
                       VIDEO_OUTPUT=Auto
                       ;;
    esac

    FR_Third_Selected=
    FR_Half_Selected=
    FR_Full_Selected=
    case "$FRAME_RATE" in
        #Third) FR_Third_Selected=selected ;;
          Half) FR_Half_Selected=selected ;;
             *) FR_Full_Selected=selected ;;
    esac

    MP4_Selected=
    TS_Selected=
    case "$STREAM_TYPE" in
        MP4) MP4_Selected=selected ;;
        *) TS_Selected=selected ;;
    esac

    VID_FLT_ON_Selected=
    VID_FLT_OFF_Selected=
    case "$VIDEO_FILTER" in
        On) VID_FLT_ON_Selected=selected ;;
        *) VID_FLT_OFF_Selected=selected ;;
    esac

    SHARPNESS_DFLT_Selected=
    SHARPNESS_SMOOTH_Selected=
    SHARPNESS_MEDIUM_Selected=
    SHARPNESS_SHARP_Selected=
    case "$SHARPNESS" in
        smooth) SHARPNESS_SMOOTH_Selected=selected ;;
        medium) SHARPNESS_MEDIUM_Selected=selected ;;
        sharp) SHARPNESS_SHARP_Selected=selected ;;
        *) SHARPNESS_DFLT_Selected=selected ;;
    esac

    CLOSED_CAPTION_NONE_Selected=
    CLOSED_CAPTION_LINE21_Selected=
    CLOSED_CAPTION_608_Selected=
    CLOSED_CAPTION_708_Selected=
    case "$CLOSED_CAPTION" in
        line21) CLOSED_CAPTION_LINE21_Selected=selected ;;
        608)
            if [ "$QVENC_BOARD" = true ] ; then
                CLOSED_CAPTION_608_Selected=selected
            else
                CLOSED_CAPTION_LINE21_Selected=selected
            fi
            ;;
        708)
            if [ "$QVENC_BOARD" = true ] ; then
                CLOSED_CAPTION_708_Selected=selected
            else
                CLOSED_CAPTION_LINE21_Selected=selected
            fi
            ;;
        *) CLOSED_CAPTION_NONE_Selected=selected ;;
    esac

    ANALOG_HDVIDEO_ON_Selected=
    ANALOG_HDVIDEO_OFF_Selected=
    case "$ANALOG_HDVIDEO" in
        Yes) ANALOG_HDVIDEO_ON_Selected=selected ;;
        *) ANALOG_HDVIDEO_OFF_Selected=selected ;;
    esac

    RESYNC_SDI_ON_Selected=
    RESYNC_SDI_OFF_Selected=
    case "$RESYNC_SDI" in
        Yes) RESYNC_SDI_ON_Selected=selected ;;
        *) RESYNC_SDI_OFF_Selected=selected ;;
    esac

    RESYNC_HDMI_ON_Selected=
    RESYNC_HDMI_OFF_Selected=
    case "$RESYNC_HDMI" in
        Yes) RESYNC_HDMI_ON_Selected=selected ;;
        *) RESYNC_HDMI_OFF_Selected=selected ;;
    esac

    DYNAMIC_BITRATE_ON_Selected=
    DYNAMIC_BITRATE_OFF_Selected=
    case "$DYNAMIC_BITRATE" in
        Yes) DYNAMIC_BITRATE_ON_Selected=selected ;;
        *) DYNAMIC_BITRATE_OFF_Selected=selected ;;
    esac

    OUT_ASI_Selected=
    OUT_NET_Selected=
    OUT_NET_FILE_Selected=
    OUT_NET_PS_Selected=
    OUT_FILE_TS_Selected=
    OUT_FILE_MP4_Selected=
    case "$OUTPUT" in
              ASI) OUT_ASI_Selected=selected ;;
       "File TS"*) OUT_FILE_TS_Selected=selected ;;
      #"File MP4"*) OUT_FILE_MP4_Selected=selected ;;
      Network*File) OUT_NET_FILE_Selected=selected ;;
      Network*PS) OUT_NET_PS_Selected=selected ;;
                *) OUT_NET_Selected=selected ;;
    esac

    AUDIO_VIDEO_BOTH_Selected=
    AUDIO_VIDEO_VIDEO_Selected=
    AUDIO_VIDEO_AUDIO_Selected=
    case "$AUDIO_VIDEO" in
        *ideo*) AUDIO_VIDEO_VIDEO_Selected=selected ;;
        *udio*) AUDIO_VIDEO_AUDIO_Selected=selected ;;
             *) AUDIO_VIDEO_BOTH_Selected=selected ;;
    esac

    AUDIO_CHANNELS_0_Selected=
    AUDIO_CHANNELS_1_Selected=
    AUDIO_CHANNELS_2_Selected=
    AUDIO_CHANNELS_4_Selected=
    case "$AUDIO_CHANNELS" in
        4) AUDIO_CHANNELS_4_Selected=selected ;;
        #1) AUDIO_CHANNELS_1_Selected=selected ;;
        #0) AUDIO_CHANNELS_0_Selected=selected ;;
        *) AUDIO_CHANNELS_2_Selected=selected ;;
    esac

    AU_OFF_Selected=
    AU_16K_Selected=
    AU_32K_Selected=
    AU_56K_Selected=
    AU_64K_Selected=
    AU_96K_Selected=
    AU_112K_Selected=
    AU_128K_Selected=
    AU_160K_Selected=
    AU_192K_Selected=
    AU_224K_Selected=
    AU_256K_Selected=
    AU_320K_Selected=
    AU_384K_Selected=
    case "$AUDIO_BITRATE" in
        #0) AU_OFF_Selected=selected ;;
        16000) AU_16K_Selected=selected ;;
        32000) AU_32K_Selected=selected ;;
        56000) AU_56K_Selected=selected ;;
        64000) AU_64K_Selected=selected ;;
        96000) AU_96K_Selected=selected ;;
        112000) AU_112K_Selected=selected ;;
        128000) AU_128K_Selected=selected ;;
        192000) AU_192K_Selected=selected ;;
        224000) AU_224K_Selected=selected ;;
        256000) AU_256K_Selected=selected ;;
        320000) AU_320K_Selected=selected ;;
        384000) AU_384K_Selected=selected ;;
        *) AU_160K_Selected=selected ;;
    esac

    AU_16Hz_Selected=
    AU_24Hz_Selected=
    AU_32Hz_Selected=
    AU_44Hz_Selected=
    AU_48Hz_Selected=
    case "$AUDIO_SAMPLE_RATE" in
        16000) AU_16Hz_Selected=selected ;;
        #24000) AU_24Hz_Selected=selected ;;
        32000) AU_32Hz_Selected=selected ;;
        #44100) AU_44Hz_Selected=selected ;;
        *) AU_48Hz_Selected=selected ;;
    esac

    MPEG2_Selected=
    H264_Selected=
    MPEG2_CBR_Selected=
    H264_CBR_Selected=
    case "$VIDEO_ENCODING" in
        MPEG2) MPEG2_Selected=selected ;;
        MPEG2*C*) MPEG2_CBR_Selected=selected ;;
        H264*C*) H264_CBR_Selected=selected ;;
        *) H264_Selected=selected ;;
    esac

    AUD_AC3_SDI_Selected=
    AUD_AC3_SPDIF_Selected=
    AUD_MPEG4_Selected=
    AUD_MPEG2_Selected=
    AUD_MPEG1_Selected=
    case "$AUDIO_ENCODING" in
        MPEG4*)    AUD_MPEG4_Selected=selected ;;
        *SDI*)     AUD_AC3_SDI_Selected=selected
                   [ "$QVENC_BOARD" != true ] && AUD_MPEG1_Selected=selected
                   [ "$QVENC_BOARD" = true -a $HAS_SDI = false ] && AUD_MPEG1_Selected=selected
                   ;;
        *Optical*)
                   AUD_AC3_SPDIF_Selected=selected
                   [ "$QVENC_BOARD" != true ] && AUD_MPEG1_Selected=selected
                   ;;
        MPEG2*)    AUD_MPEG2_Selected=selected ;;
        *)         AUD_MPEG1_Selected=selected ;;
    esac

    VID_COM_Selected=
    VID_SVID_Selected=
    VID_HDMI_Selected=
    VID_SDI_Selected=
    case "$VIDEO_INPUT" in
        HDMI) VID_HDMI_Selected=selected ;;
        S-Video) VID_SVID_Selected=selected ;;
        SDI) VID_SDI_Selected=selected ;;
        *) VID_COM_Selected=selected ;;
    esac

    VID_4x3_Selected=
    VID_16x9_Selected=
    case "$VIDEO_ASPECT" in
        16x9) VID_16x9_Selected=selected ;;
        *) VID_4x3_Selected=selected ;;
    esac

    ENC_ARQ_Selected=
    ENC_TCP_Selected=
    ENC_RTP_Selected=
    ENC_UDP_Selected=
    ENC_RTSP_Selected=
    ENC_RTMP_Selected=
    ENC_MSS_Selected=
    ENC_HLS_Selected=
    ENC_QVSERVER_Selected=
    ENC_QVSERVER_TSR_Selected=
    ENC_PROMPEG_Selected=
    ENC_ZIXI_Selected=
    case "$TRANSPORT" in
        Zixi)
            if [ $HAS_ZIXI = 1 ] ; then
                ENC_ZIXI_Selected=selected
            else
                ENC_UDP_Selected=selected
                TRANSPORT=UDP
            fi
            ;;
        RTSP)
            if [ $HAS_RTSP = 1 ] ; then
                ENC_RTSP_Selected=selected
            else
                ENC_UDP_Selected=selected
                TRANSPORT=UDP
            fi
            ;;
        HLS)
            if [ $HAS_HLS = 1 ] ; then
                ENC_HLS_Selected=selected
            else
                ENC_UDP_Selected=selected
                TRANSPORT=UDP
            fi
            ;;
        MSS)
            if [ $HAS_MSS = 1 ] ; then
                ENC_MSS_Selected=selected
            else
                ENC_UDP_Selected=selected
                TRANSPORT=UDP
            fi
            ;;
        RTMP)
            if [ $HAS_RTMP = 1 ] ; then
                ENC_RTMP_Selected=selected
            else
                ENC_UDP_Selected=selected
                TRANSPORT=UDP
            fi
            ;;
        QVSERVER)
            if [ $HAS_QVSERVER = 1 ] ; then
                ENC_QVSERVER_Selected=selected
            else
                ENC_UDP_Selected=selected
                TRANSPORT=UDP
            fi
            ;;
        QVSERVER_TSR)
            if [ $HAS_QVSERVER = 1 ] ; then
                ENC_QVSERVER_TSR_Selected=selected
            else
                ENC_UDP_Selected=selected
                TRANSPORT=UDP
            fi
            ;;
        RTP) ENC_RTP_Selected=selected ;;
        TCP)
            if [ $HAS_TCP = 1 ] ; then
                ENC_TCP_Selected=selected
            else
                ENC_UDP_Selected=selected
                TRANSPORT=UDP
            fi
            ;;
        ARQ)
            if [ $HAS_ARQ = 1 ] ; then
                ENC_ARQ_Selected=selected
            else
                ENC_UDP_Selected=selected
                TRANSPORT=UDP
            fi
            ;;
        ProMPEG*)
            if [ $HAS_FEC = 1 ] ; then
                ENC_PROMPEG_Selected=selected
            else
                ENC_UDP_Selected=selected
                TRANSPORT=UDP
            fi
            ;;
        *) ENC_UDP_Selected=selected ;;
    esac

    SDP1_CHECKED=
    SDP0_CHECKED=
    case "$DO_SDP" in
        1) SDP1_CHECKED=checked ;;
        *) SDP0_CHECKED=checked ;;
    esac

    METADATA1_CHECKED=
    METADATA0_CHECKED=
    case "$DO_METADATA" in
        1) METADATA1_CHECKED=checked ;;
        *) METADATA0_CHECKED=checked ;;
    esac

    SEQ_0XFFFF_HACK_YES_CHECKED=
    SEQ_0XFFFF_HACK_NO_CHECKED=
    case "$SEQ_0XFFFF_HACK" in
        yes) SEQ_0XFFFF_HACK_YES_CHECKED=checked ;;
          *) SEQ_0XFFFF_HACK_NO_CHECKED=checked ;;
    esac

cat <<!
<html>
<head>
  <!-- Copyright 2004-2021 QVidium Technologies, Inc. All rights reserved. -->
  <title>Video Setup</title>
  <link href="/style.css" type="text/css" rel="stylesheet">
  <link href="/tabbed_panel.css" type="text/css" rel="stylesheet">
  <SCRIPT LANGUAGE=JAVASCRIPT>

  function convertBitrate(str) {
    var ValidChars = "1234567890.";
    var ValidMultiplier = "MK";
    var multiplier = 1;
    
    var Char;
    var i = 0;
    var start = 0;
    var end = str.length;
    var value;
    
    // Skip over leadimng spaces
    while ( i < str.length ) {
        Char = str.charAt(i);
        if ( Char == " " ) { i = i + 1; continue; }
        break;
    }
    // i is now the new start
    start = i;
    
    // Read in numberic part
    while ( i < str.length ) {
        Char = str.charAt(i);
        if ( ValidChars.indexOf(Char) == -1 ) { break; }
        i = i + 1;
    }
    // Now at end of a floating-point number
    end = i;
    
    if ( start == end ) return 0;
    
    // Skip over any spaces and check for multiplier
    while ( i < str.length ) {
        Char = str.charAt(i);
        i = i + 1;
        if ( Char == " " ) { continue; }
        if ( Char == "M" ) { multiplier = 1000000; break; }
        if ( Char == "K" ) { multiplier = 1000; break; }
    }
    
    value = str.substring(start,end) * multiplier;
    
    // In case they forgot to add a Mbps or Kbps suffix
    if ( value <= 25 ) { value = 1000000 * value;}
    
    return value;   
  }

  function IsNumeric(str) {
    var ValidChars = "0123456789";
    var Char;

    for (i = 0; i < str.length; i++) {
      Char = str.charAt(i);
      if (ValidChars.indexOf(Char) == -1) return false;
    }
    return true;
  }

  function verifyIP (IPvalue) {
    errorString = "";
    theName = "IPaddress";

    var ipArray = IPvalue.match(/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/);

    if (IPvalue == "0.0.0.0")
      errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';
    else if (IPvalue == "255.255.255.255")
      errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';
    if (ipArray == null)
      errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
    else {
      for (i = 1; i < 5; i++) {
        thisSegment = ipArray[i];
        if (thisSegment > 255) {
          errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
          i = 5;
        }
      }
    }
    extensionLength = 3;
    if (errorString != "") {
      alert (errorString);
      return false;
    }
    return true;
  }

  function changeTransport(elemid) {
    var item = document.getElementById(elemid);
    var ind = item.selectedIndex;
    var value = item.options[ind].value;
    document.getElementById("enc_label").style.display = "";
    document.getElementById("arqportrow_label").style.display = "";
    document.getElementById("latency_label").style.display = "none";
    document.getElementById("enc_type").style.display = "none";
    document.getElementById("stream_pw").style.display = "none";
    document.getElementById("zixi_opts").style.display = "none";
    if ( value == "HLS") {
      document.getElementById("udp_port").value = "playlist";
    } else if (value == "RTMP" || value == "MSS") {
      document.getElementById("udp_port").value = "";
    } else {
      document.getElementById("udp_port").value = 10000;
    }
    if (value == "RTMP" || value == "MSS" || value == "HLS") {
      document.getElementById("enc_label").style.display = "none";
      document.getElementById("arqportrow_label").style.display = "none";
      document.getElementById("ip_addr_label").innerHTML = "URI [1]";
      document.getElementById("udp_port_label").innerHTML = "Stream Name [1]";
      document.getElementById("ip_addr_info_label").innerHTML = "[1] URI and Stream Name are $RTMP_STR";
    } else if (value == "Zixi") {
      document.getElementById("ip_addr_label").innerHTML = "DNS Name or IP Address [1]";
      document.getElementById("udp_port_label").innerHTML = "Stream Port [1]";
      document.getElementById("arq_port_label").innerHTML = "Stream Name [1]";
      document.getElementById("latency_label").style.display = "";
      document.getElementById("enc_type").style.display = "";
      document.getElementById("stream_pw").style.display = "";
	  document.getElementById("zixi_opts").style.display = "";
      document.getElementById("ip_addr_info_label").innerHTML = "[1] Only DNS/IP, Stream & and Name are required. [2] Adaptation requires VBR";
    } else if (value.indexOf("TSR") >= 0) {
      document.getElementById("ip_addr_label").innerHTML = "Destination IP Address";
      document.getElementById("udp_port_label").innerHTML = "UDP&nbsp;Port";
      document.getElementById("arq_port_label").innerHTML = "Redundant Stream&nbsp;Delay&nbsp;[1]";
      document.getElementById("ip_addr_info_label").innerHTML = "[1] Number of packets second stream is delayed.";
    } else if (value == "QVSERVER") {
      document.getElementById("arqportrow_label").style.display = "none";
      document.getElementById("ip_addr_label").innerHTML = "Destination IP Address";
      document.getElementById("udp_port_label").innerHTML = "UDP&nbsp;Port";
      document.getElementById("ip_addr_info_label").innerHTML = "";
    } else if (value == "ARQ") {
      document.getElementById("ip_addr_label").innerHTML = "Destination IP [1]";
      document.getElementById("udp_port_label").innerHTML = "UDP&nbsp;Port";
      document.getElementById("arq_port_label").innerHTML = "ARQ&nbsp;Port";
      document.getElementById("ip_addr_info_label").innerHTML = "[1] Cannot send Multicast with ARQ";
    } else { //!ARQ
      document.getElementById("ip_addr_label").innerHTML = "Destination IP or Multicast Address [1]";
      document.getElementById("arqportrow_label").style.display = "none";
      document.getElementById("udp_port_label").innerHTML = "UDP&nbsp;Port";
      document.getElementById("ip_addr_info_label").innerHTML = "[1] Multicast Address is only valid for RTP or UDP";
    }
  }

  function ManageTabPanelDisplay() {
    //
    // Between the parenthesis, list the id's of the div's that
    //     will be effected when tabs are clicked. List in any
    //     order. Put the id's in single quotes (apostrophes)
    //     and separate them with a comma -- all one line.
    //
    var idlist = new Array('tab1focus','tab2focus','tab3focus',
                           'tab1ready','tab2ready','tab3ready',
                           'content1','content2','content3');

    if (arguments.length < 1) { return; }
    for (var i = 0; i < idlist.length; i++) {
      var block = false;
      for (var ii = 0; ii < arguments.length; ii++) {
        if (idlist[i] == arguments[ii]) {
          block = true;
          break;
        }
      }
      if (block) {
        document.getElementById(idlist[i]).style.display = "block";
      }
      else {
        document.getElementById(idlist[i]).style.display = "none";
      }
    }
  }

  function verify_audio_bitrate()
  {
    var selObj = document.forms[0].AUDIO_ENCODING;
    var selIndex = selObj.selectedIndex;
    if (selIndex == 0)
    {
      selObj = document.forms[0].AUDIO_BITRATE;
      selIndex = selObj.selectedIndex;
      if (selIndex > 10)
      {
        var ans = confirm('The QVidium decoder does not support audio bit rates above 256000 for AAC audio.\n\nShould we change the audio bit rate to 256000?');
        if (ans)
        {
      selObj.selectedIndex = 10;
        }
      }
    }
  }
  
  function verify(arg)
  {
    //var ipaddr = document.video.IPADDR_OR_HOSTNAME.value;
    var tmp;
    var tmp1;
    var tmp2;
    var nMaxBitrate;

    //if (ipaddr.length > 0 && verifyIP(ipaddr) == false)
    //{
        //return false;
    //}

    verify_audio_bitrate();

    nMaxBitrate = 25000000;
    if ((document.forms[0].AUDIO_CHANNELS.selectedIndex == 1) &&
        (document.forms[0].AUDIO_VIDEO.selectedIndex == 0))
    {
      nMaxBitrate = 15000000;
    }
    tmp = document.forms[0].TS_BITRATE.value;
    tmp1 = convertBitrate(tmp);
    if ( tmp != tmp1 ) 
    {
      tmp = tmp1;
      var ans = confirm('Note: Bitrate changed to "'+tmp+'", do you want to save this?');
      if (ans)
      {
        document.forms[0].TS_BITRATE.value = tmp;
      }
      else
      {
        return false;
      }
    }
    
    if (IsNumeric(tmp) == false || tmp < 224000 || tmp > nMaxBitrate)
    {
      alert('Stream Bit Rate "'+tmp+'" is not valid [224000,'+nMaxBitrate+'].');
      return false;
    }
    if ("$QVSD_BOARD" == false)
    {
        tmp = document.forms[0].SD_SDI_BITRATE.value;
        if (IsNumeric(tmp) == false || tmp < 224000 || tmp > nMaxBitrate)
        {
          if (tmp != 0)
          {
            alert('SD-SDI Bit Rate "'+tmp+'" is not valid [0, or 224000,'+nMaxBitrate+'].');
            return false;
          }
        }
    }
    tmp = document.forms[0].DTS_DELAY_FROM_PCR.value;
    if (IsNumeric(tmp) == false || tmp < 80 || tmp > 500)
    {
      alert('DTS delay from PCR "'+tmp+'" is not valid [80-500].');
      return false;
    }
    
    // Check that ARQ port is numeric
    tmp1 = document.forms[0].TRANSPORT.value;
    if (tmp1=="ARQ")
    {
        tmp = document.forms[0].ARQ_PORT.value;
        if (IsNumeric(tmp) == false || tmp < 1 || tmp > 32767)
        {
          alert('ARQ port "'+tmp+'" is not valid [1-32767].');
          return false;
        }
    }
    
    // Check for profile name conflict for Save As...
    //rdf
    var oldname=("$OLDNAME");
    var name=document.forms[0].NAME.value;
    if (arg == 2 || (arg==1 && name != oldname)) 
    {
      tmp=("$NAMES");
      var nameList = tmp.split(",");
      var i;
      for (i in nameList)
      {
        if (myCompare(nameList[i], name) == 0)
        {
          alert("Warning: Profile name already taken");
          return false;
        }
      }
    }
    if (arg == 1) 
    {
      document.getElementById("state_id").value = "Save";
//      document.getElementById("btn_sav_as").disabled = true;
      document.getElementById("editForm").submit();
    }
    else if (arg == 2) 
    {
      document.getElementById("state_id").value = "SaveAs";
//      document.getElementById("btn_sav").disabled = true;
      document.getElementById("editForm").submit();
    }
    return true;
  }

  function myCompare(str1,str2)
  {
    if (str1.includes(str2) && str2.includes(str1))
    {
      return 0;
    }
    return 1;
  }
  
  function changeMode() {
    var x = document.getElementById("STREAM_MODE").value;
    if (x == "Constant Bit Rate (CBR)") document.getElementById("adaptation").disabled = true;
    else  document.getElementById("adaptation").disabled = false;
  }
  
  function xx()
  {
    var bond = document.video.BOND_PORTS.value;

    if (bond == false)
    {
        document.video.LAN1_PERCENT.disabled = true;
    }
    else
    {
        document.video.LAN1_PERCENT.disabled = false;
    }
    return true;
  }
  
  function make_key()
  {
    var type = document.getElementById("aes_type").value;
    var key;
    var len;
    
    if (type == "AES-256" || type == "ChaCha20") {
        len = 64;
    } else if (type == "AES-192") {
        len = 48;
    } else if (type == "AES-128") {
        len = 32;
    } else if (type == "ChaCha20") {
    } else {
        len = 0;
    }
    if (len == 0) key = "";
    else {
        key = "";
        var i=0;
        while (i < len) {
            let digit = Math.floor(Math.random() * 16);
            key += digit.toString(16);
            i += 1;
        }
    }

    document.getElementById("enc_key").value = key;
    return true
  }
  
  function myInit()
  {
    var tp=("$TRANSPORT");
    if ("$HAS_ZIXI") {
	    changeMode();
        if ( tp != "Zixi") {
          document.getElementById("latency_label").style.display = "none";
          document.getElementById("enc_type").style.display = "none";
          document.getElementById("stream_pw").style.display = "none";
		  document.getElementById("zixi_opts").style.display = "none";
        } else{
          document.getElementById("ip_addr_info_label").innerHTML = "[1] Only DNS/IP, Stream & and Name are required. [2] Adaptation requires VBR";
		}
    }
    if ("$HAS_QVSTREAM") {
      if ( tp != "Zixi" && tp != "ARQ") {
        document.getElementById("enc_label").style.display = "none";
      }
    }
    return true;
  }
  </SCRIPT>
</head>
<body onload="myInit()">
 <h3>Encoder Profile</h3>
 <p>
 <b><a href="/EncoderProfile.html" target="_blank">Press here for Help</a></b>
 <p>
 <!--
  <form name="video" method="get" action="encoder-setup.cgi" onSubmit="return verify()">
  -->
  <form id="editForm" name="video" method="get" action="encoder-setup.cgi">
  <input type="hidden" name="state" value="edit" id="state_id">
  <input type="hidden" name="PROFILE" value="$PROFILE_BASE">

  <TABLE class=props cellSpacing="1" cellPadding="10" border="1">
   <tr align="left">
    <td>Profile Name</td>
    <td><input name="NAME" size="50" maxlength="50" value="$NAME" type="text"></td>
   </tr>
  </TABLE>
  <p>
  <table width=600 style="border-collapse:collapse;" border="0" cellpadding="0" cellspacing="0">
   <tr>
    <td>
     <div id="tab1focus" class="tab tabfocus" style="display:block;">
      Basic
     </div>
     <div id="tab1ready" class="tab tabhold" style="display:none;">
      <span onclick="ManageTabPanelDisplay('tab1focus','tab2ready','tab3ready','content1')">Basic</span>
     </div>
    </td>
    <td width="5"> </td>
    <td>
     <div id="tab2focus" class="tab tabfocus" style="display:none;">
      Advanced Encoding
     </div>
     <div id="tab2ready" class="tab tabhold" style="display:block;">
      <span onclick="ManageTabPanelDisplay('tab1ready','tab2focus','tab3ready','content2')">Advanced Encoding</span>
     </div>
    </td>
    <td width="5"> </td>
    <td>
     <div id="tab3focus" class="tab tabfocus" style="display:none;">
      Advanced Networking
     </div>
     <div id="tab3ready" class="tab tabhold" style="display:block;">
      <span onclick="ManageTabPanelDisplay('tab1ready','tab2ready','tab3focus','content3')">Advanced Networking</span>
     </div>
    </td>
    <td class="tabspace" width="30"> </td>
   </tr>
   <tr>
    <td colspan="10">

     <!--  Basic Parameters -->
     <div id="content1" class="tabcontent" style="display:block;">

      <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
!
    ASI_OUTPUT_OPTION=
    [ $HAS_ASI = true ] && ASI_OUTPUT_OPTION="<option $OUT_ASI_Selected>ASI</option>"
    cat <<!
       <tr align=left>
    <th colSpan="2">Output</th>
       </tr>
       <tr>
        <td>Device</td>
        <td>
         <select name="OUTPUT">
          <option $OUT_NET_Selected>Network</option>
          <option $OUT_NET_FILE_Selected>Network + File</option>
          <option $OUT_NET_PS_Selected>Network PS</option>
          $ASI_OUTPUT_OPTION
          <option $OUT_FILE_TS_Selected>File TS</option>
          <!--
          <option $OUT_FILE_MP4_Selected>File MP4 (Baseline Only)</option>
          -->
         </select>
        </td>
       </tr>
      </table>
      <br>
      <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
       <tr align=left>
       <th colSpan="2">Encoding</th>
       </tr>
       <tr>
        <td>Video Input</td>
        <td>
         <select name="VIDEO_INPUT">
!
    if [ "$QVENC_BOARD" = true ] ; then
        AUD_AC3_SPDIF_OPTION="<option $AUD_AC3_SPDIF_Selected>AC3 Pass Through on Optical</option>"
        SDI_OPT=
        if [ "$HAS_SDI" = true ] ; then
            SDI_OPT="<option $VID_SDI_Selected>SDI</option>"
            AUD_AC3_SDI_OPTION="<option $AUD_AC3_SDI_Selected>AC3 Pass Through on SDI</option>"
        fi
        cat <<!
          $SDI_OPT
          <option $VID_COM_Selected>Composite</option>
          <option $VID_SVID_Selected>S-Video</option>
!
    elif [ $HAS_SDI = false ] ; then
        cat <<!
          <option $VID_COM_Selected>Composite</option>
          <option $VID_SVID_Selected>S-Video</option>
!
    else
        cat <<!
          <option $VID_HDMI_Selected>HDMI</option>
          <option $VID_SDI_Selected>SDI</option>
!
    fi
cat <<!
         </select>
        </td>
       </tr>
       <tr align="left">
        <td>Stream Bit Rate</td>
        <td><input name="TS_BITRATE" size="8" maxlength="8" value="$TS_BITRATE" type="text"></td>
       </tr>
       <!--
       <tr align="left">
        <td>Video Bit Rate</td>
        <td><input name="VIDEO_BITRATE" size="8" maxlength="8" value="$VIDEO_BITRATE" type="text"></td>
       </tr>
       -->
       <tr>
        <td>Video Encoding</td>
        <td>
         <select name="VIDEO_ENCODING">
           <option $H264_Selected>H264</option>
           <option $MPEG2_Selected>MPEG2</option>
           <!--
           <option $H264_CBR_Selected>H264 Constant Quantization</option>
           <option $MPEG2_CBR_Selected>MPEG2 Constant Quantization</option>
           -->
         </select>
        </td>
       </tr>
       <tr>
        <td>Audio Bit Rate</td>
        <td>
         <select name="AUDIO_BITRATE">
          <option $AU_16K_Selected>16000</option>
          <option $AU_32K_Selected>32000</option>
          <option $AU_56K_Selected>56000</option>
          <option $AU_64K_Selected>64000</option>
          <option $AU_96K_Selected>96000</option>
          <option $AU_112K_Selected>112000</option>
          <option $AU_128K_Selected>128000</option>
          <option $AU_160K_Selected>160000</option>
          <option $AU_192K_Selected>192000</option>
          <option $AU_224K_Selected>224000</option>
          <option $AU_256K_Selected>256000</option>
          <option $AU_320K_Selected>320000</option>
          <option $AU_384K_Selected>384000</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Audio Encoding</td>
        <td>
         <select name="AUDIO_ENCODING">
          <option $AUD_MPEG4_Selected>MPEG4 AAC</option>
          <option $AUD_MPEG2_Selected>MPEG2 AAC</option>
          <option $AUD_MPEG1_Selected>MPEG1 Layer2</option>
          $AUD_AC3_SDI_OPTION
          $AUD_AC3_SPDIF_OPTION
         </select>
        </td>
       </tr>
       <tr>
        <td>Audio Sampling Rate</td>
        <td>
         <select name="AUDIO_SAMPLE_RATE">
          <option $AU_16Hz_Selected>16000</option>
          <option $AU_32Hz_Selected>32000</option>
          <!--
          <option $AU_44Hz_Selected>44100</option>
          -->
          <option $AU_48Hz_Selected>48000</option>
         </select>
        </td>
       </tr>
      </table>
      <br>
      <table width=750 class=props border="1" cellpadding="2" cellspacing="1">
!

    [ $HAS_RTSP = 1 ] && RTSP_OPTION="<option $ENC_RTSP_Selected>RTSP</option>"
    IP_ADDR_LABEL='Destination IP or Multicast Address [1]'
    UDP_PORT_LABEL='UDP&nbsp;Port'
    ARQ_PORT_LABEL='ARQ&nbsp;Port'
    IP_ADDR_INFO_LABEL='[1] Multicast Address is only valid for RTP or UDP'
    SELECT_PARAMS="id=\"TRANSPORT\" onChange=\"changeTransport('TRANSPORT');\""
    if [ $HAS_HLS = 1 ] ; then
        HLS_OPTION="<option $ENC_HLS_Selected>HLS</option>"
        if [ "$TRANSPORT" = HLS ] ; then
            IP_ADDR_LABEL='URI [1]'
            UDP_PORT_LABEL='Stream Name [1]'
            IP_ADDR_INFO_LABEL="[1] URI and Stream Name are $RTMP_STR"
        fi
    fi
    if [ $HAS_MSS = 1 ] ; then
        MSS_OPTION="<option $ENC_MSS_Selected>MSS</option>"
        if [ "$TRANSPORT" = MSS ] ; then
            IP_ADDR_LABEL='URI [1]'
            UDP_PORT_LABEL='Stream Name [1]'
            IP_ADDR_INFO_LABEL="[1] URI and Stream Name are $RTMP_STR"
        fi
    fi
    if [ $HAS_RTMP = 1 ] ; then
        RTMP_OPTION="<option $ENC_RTMP_Selected>RTMP</option>"
        if [ "$TRANSPORT" = RTMP ] ; then
            IP_ADDR_LABEL='URI [1]'
            UDP_PORT_LABEL='Stream Name [1]'
            IP_ADDR_INFO_LABEL="[1] URI and Stream Name are $RTMP_STR"
        fi
    fi
    if [ $HAS_ZIXI = 1 ] ; then
        ZIXI_OPTION="<option $ENC_ZIXI_Selected>Zixi</option>"
        if [ "$TRANSPORT" = Zixi ] ; then
            IP_ADDR_LABEL='DNS Name or IP Address [1]'
            UDP_PORT_LABEL='Stream Port [1]'
            ARQ_PORT_LABEL='Stream Name [1]'
            IP_ADDR_INFO_LABEL="[1] DNS/IP and Stream Port and Name are required"
        fi
    fi
    if [ $HAS_QVSERVER = 1 ] ; then
        QVSERVER_OPTION="<option $ENC_QVSERVER_Selected>QVSERVER</option>"
        QVSERVER_TSR_OPTION="<option $ENC_QVSERVER_TSR_Selected value='QVSERVER_TSR' >QVSERVER + TSR</option>"
        if [ "$TRANSPORT" = QVSERVER -o "$TRANSPORT" = QVSERVER_TSR ] ; then
            IP_ADDR_LABEL='Destination IP Address'
            if [ "$TRANSPORT" = QVSERVER_TSR ] ; then
                ARQ_PORT_LABEL='Redundant Stream&nbsp;Delay&nbsp;[1]'
                IP_ADDR_INFO_LABEL='[1] Number of packets second stream is delayed.'
            else
                ARQ_PORT_LABEL='ARQ&nbsp;Port&nbsp;[1]'
                IP_ADDR_INFO_LABEL='[1] Not Used.'
            fi
        fi
    fi
    [ $HAS_ARQ = 1 ] && ARQ_OPTION="<option $ENC_ARQ_Selected>ARQ</option>"
    [ $HAS_TCP = 1 ] && TCP_OPTION="<option $ENC_TCP_Selected>TCP</option>"
    [ $HAS_FEC = 1 ] && FEC_OPTION="<option $ENC_PROMPEG_Selected>ProMPEG FEC</option>"
    cat <<!

       <tr align=left><th colSpan="2">Network</th></tr>
       <tr>
        <td>IP&nbsp;Transport</td>
        <td>
         <select name="TRANSPORT" $SELECT_PARAMS >
          $ARQ_OPTION
          <option $ENC_RTP_Selected>RTP</option>
          <option $ENC_UDP_Selected>UDP</option>
          $ZIXI_OPTION
          $TCP_OPTION
          $FEC_OPTION
          $HLS_OPTION
          $MSS_OPTION
          $RTMP_OPTION
          $RTSP_OPTION
          $QVSERVER_OPTION
          $QVSERVER_TSR_OPTION
         </select>
        </td>
       </tr>
!
    cat <<!
       <tr align="left">
        <td><div id="ip_addr_label">$IP_ADDR_LABEL</div></td>
        <td><input name="IPADDR_OR_HOSTNAME" size="40" maxlength="120" value="$IPADDR_OR_HOSTNAME" type="text"></td>
       </tr>
       <tr align="left">
        <td><div id="udp_port_label">$UDP_PORT_LABEL</div></td>
        <td><input name="UDP_PORT" id="udp_port" size="32" maxlength="120" value="$UDP_PORT" type="text"></td>
       </tr>
       <tr id="arqportrow_label" align="left">
        <td><div id="arq_port_label">$ARQ_PORT_LABEL</div></td>
        <td><input name="ARQ_PORT" size="16" maxlength="15" value="$ARQ_PORT" type="text"></td>
       </tr>
!
    if [ $HAS_ZIXI = 1 ] ; then
        cat <<!
            <tr id="latency_label" align="left">
             <td>Latency (ms)</td>
             <td><input name="LATENCY" size="8" maxlength="8" value="$LATENCY" type="text"></td>
            </tr>
!
    fi
    if [ $HAS_ZIXI = 1 ] ; then
        cat <<!
            <tr id="stream_pw" align="left">
             <td>Stream Password</td>
             <td><input name="STREAM_PASSWORD" size="32" maxlength="32" value="$STREAM_PASSWORD" type="text"></td>
            </tr>
            <tr id="enc_type" align="left">
             <td>Encryption Type</td>
             <td>
              <select id="aes_type" name="ENC_TYPE">
               <option $NOENC_Selected>None</option>
               <option $AES128_Selected>AES-128</option>
               <option $AES192_Selected>AES-192</option>
               <option $AES256_Selected>AES-256</option>
               <option $CHACHA20_Selected>ChaCha20</option>
              </select>
                <button type="button" onClick=make_key()>Generate Key</button>
             </td>
            </tr>
!
    fi
    if [ $HAS_QVSTREAM = 1 -o $HAS_ZIXI = 1 ] ; then
        cat <<!
            <tr id="enc_label" align="left">
             <td><div id="enckey_label">Encryption Key</div></td>
             <td><input id="enc_key" name="ENCRYPTION_PASSWORD" size="64" maxlength="64" value="$ENCRYPTION_PASSWORD" type="text"></td>
            </tr>
!
    fi
    if [ $HAS_ZIXI = 1 ] ; then
        cat <<!
            <tr id="zixi_opts" align="left">
             <td>Options</td>
             <td>Log Level
              <select name="ZIXI_LOGLEVEL">
               <option $LOGM_Selected>Off</option>
               <option $LOG1_Selected>Debug</option>
               <option $LOG2_Selected>Info</option>
               <option $LOG3_Selected>Warning</option>
               <option $LOG4_Selected>Error</option>
               <option $LOG5_Selected>Critical</option>
              </select>
                <input type="checkbox" id="adaptation" name="ADAPTATION" value="1" $ADAPT_Checked>
				<label for="adaptation">Enable Adaptive Bitrate [2]</label>
             </td>
            </tr>
!
    fi
    cat <<!
       <tr>
        <td colSpan="2" nowrap><div id="ip_addr_info_label">$IP_ADDR_INFO_LABEL</div></td>
       </tr>

      </table>
    </div>

    <!-- Advanced Encoding Parameters -->
    <div id="content2" class="tabcontent" style="display:none;">
    <table>
     <tr valign="top">
      <td>
      <table width=350 class=props border="1" cellpadding="2" cellspacing="1">
       <tr align=left><th colSpan="2">Encoding</th></tr>
       <tr align="left">
        <td>Stream Mode</td>
        <td>
         <select id="STREAM_MODE" name="STREAM_MODE" onchange="changeMode()">
           <option $CBR_Selected>Constant Bit Rate (CBR)</option>
           <option $CAPPED_VBR_Selected>Capped VBR</option>
           <option $LOW_DELAY_VBR_Selected>Low Delay VBR</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Closed Caption (CC)</td>
        <td>
         <select name="CLOSED_CAPTION">
          <option value="none" $CLOSED_CAPTION_NONE_Selected>None</option>
          <option value="line21" $CLOSED_CAPTION_LINE21_Selected>Line 21</option>
!
    if [ "$QVENC_BOARD" = true ] ; then
        cat <<!
          <option value="608" $CLOSED_CAPTION_608_Selected>608 Anc Data</option>
          <option value="708" $CLOSED_CAPTION_708_Selected>708 Anc Data</option>
!
    fi
    cat <<!
         </select>
        </td>
       </tr>
       <tr>
        <td>DTS delay from PCR<br>(80 to 500)</td>
        <td><input name="DTS_DELAY_FROM_PCR" size="8" maxlength="8" value="$DTS_DELAY_FROM_PCR" type="text"></td>
       </tr>
       <!--
       <tr>
        <td>Low Delay Rate Control Algorithm</td>
        <td>
         <select name="REMUX">
          <option $REMUX_LIVE_Selected>Live</option>
          <option $REMUX_PVR_Selected>PVR</option>
         </select>
        </td>
       </tr>
       -->
       <tr>
        <td>Audio/Video</td>
        <td>
         <select id="AUDIO_VIDEO" name="AUDIO_VIDEO">
          <option $AUDIO_VIDEO_BOTH_Selected>Both</option>
          <option $AUDIO_VIDEO_VIDEO_Selected>Video Only</option>
          <option $AUDIO_VIDEO_AUDIO_Selected>Audio Only</option>
         </select>
        </td>
       </tr>
!
    if [ "$QVENC_BOARD" = true -o "$QVSD_BOARD" = true ] ; then
        cat <<!
       <tr>
        <td>Analog audio 6dB attenuate input</td>
        <td>
         <select name="AVIN_6DB_ATTN">
          <option $AVIN_6DB_ATTN_ON_Selected>Yes</option>
          <option $AVIN_6DB_ATTN_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
!
    fi
    if [ "$QVENC_BOARD" = true ] ; then
        cat <<!
       <tr>
        <td>Analog audio for SDI input</td>
        <td>
         <select name="ANALOG_HDVIDEO">
          <option $ANALOG_HDVIDEO_ON_Selected>Yes</option>
          <option $ANALOG_HDVIDEO_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
!
    fi
    if [ $HAS_SDI != false ] ; then
        cat <<!
       <tr>
        <td>SD-SDI Bit Rate</td>
        <td><input name="SD_SDI_BITRATE" size="8" maxlength="8" value="$SD_SDI_BITRATE" type="text"></td>
       </tr>
!
    fi
    cat <<!
       <tr>
        <td>Audio Channels</td>
        <td>
         <select id="AUDIO_CHANNELS" name="AUDIO_CHANNELS">
          <!--
          <option $AUDIO_CHANNELS_1_Selected>1</option>
          -->
          <option $AUDIO_CHANNELS_2_Selected>2</option>
          <option $AUDIO_CHANNELS_4_Selected>4</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Fixed Audio PES</td>
        <td>
         <select name="AUDIO_FIXED_PES">
          <option $AUDIO_FIXED_PES_YES_Selected>Yes</option>
          <option $AUDIO_FIXED_PES_NO_Selected>No</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Video Filtering</td>
        <td>
         <select name="VIDEO_FILTER">
          <option $VID_FLT_ON_Selected>On</option>
          <option $VID_FLT_OFF_Selected>Off</option>
         </select>
        </td>
       </tr>
       <!--
       -->
       <tr>
        <td>Video Sharpness</td>
        <td>
         <select name="SHARPNESS">
          <option $SHARPNESS_DFLT_Selected>default</option>
          <option $SHARPNESS_SMOOTH_Selected>smooth</option>
          <option $SHARPNESS_MEDIUM_Selected>medium</option>
          <option $SHARPNESS_SHARP_Selected >sharp</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Video Frame Rate</td>
        <td>
         <select name="FRAME_RATE">
          <option $FR_Full_Selected>Full</option>
          <option $FR_Half_Selected>Half</option>
          <!--
          <option $FR_Third_Selected>Third</option>
          -->
         </select>
        </td>
       </tr>
       <tr>
        <td>H264 Video Resolution</td>
        <td>
         <select name="VIDEO_SD_RES">
          <option $VID_default_Selected>Full</option>
!
    if [ $HAS_SDI != false ] ; then
        cat <<!
          <option $VID_3_4_HD_Selected>3/4 HD</option>
          <option $VID_HALF_HD_Selected>1/2 HD</option>
!
    fi
        cat <<!
          <option $VID_D1_Selected>D1</option>
          <option $VID_HALF_D1_Selected>Half</option>
          <option $VID_CIF_Selected>CIF</option>
          <!--
          <option $VID_QCIF_Selected>QCIF</option>
          -->
          <option $VID_VGA_Selected>VGA</option>
          <option $VID_QVGA_Selected>QVGA</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>D1/Half/CIF/VGA<br>Progressive Output</td>
        <td>
         <select name="SD_PROGRESSIVE">
          <option $SD_P_ON_Selected>Yes</option>
          <option $SD_P_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
       <!--
       <tr align="left">
        <td>Output Format</td>
        <td>
         <select name="VIDEO_OUTPUT">
          <option $FORMAT_AUTO_Selected>Auto</option>
          <option $FORMAT_1080i60_Selected>1920x1080@60i</option>
          <option $FORMAT_1080i50_Selected>1920x1080@50i</option>
          <option $FORMAT_720p60_Selected>1280x720@60p</option>
          <option $FORMAT_720p50_Selected>1280x720@50p</option>
          <option $FORMAT_480i60_Selected>720x480@60i</option>
          <option $FORMAT_576i50_Selected>720x576@50i</option>
          <optgroup label="-------------">
          <option $FORMAT_1080p60_Selected>1920x1080@60p</option>
          <option $FORMAT_1080p50_Selected>1920x1080@50p</option>
          <option $FORMAT_480p60_Selected>720x480@60p</option>
          <option $FORMAT_576p50_Selected>720x576@50p</option>
          <option $FORMAT_352i60_Selected>352x480@60i</option>
          <option $FORMAT_352i50_Selected>352x576@50i</option>
          <option $FORMAT_240p30_Selected>352x240@30p</option>
          <option $FORMAT_288p25_Selected>352x288@25p</option>
          <optgroup>
         </select>
        </td>
       </tr>
       -->
       <tr>
        <td>Video Aspect Ratio</td>
        <td>
         <select name="VIDEO_ASPECT">
          <option $VID_4x3_Selected>4x3</option>
          <option $VID_16x9_Selected>16x9</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Number P frames</td>
        <td>
         <select name="NUM_P_FRAMES">
          <option $P_FRAME_0_Selected>0</option>
          <option $P_FRAME_1_Selected>1</option>
          <option $P_FRAME_2_Selected>2</option>
          <option $P_FRAME_3_Selected>3</option>
          <option $P_FRAME_4_Selected>4</option>
          <option $P_FRAME_5_Selected>5</option>
          <option $P_FRAME_9_Selected>9</option>
          <option $P_FRAME_14_Selected>14</option>
          <option $P_FRAME_19_Selected>19</option>
          <option $P_FRAME_29_Selected>29</option>
          <option $P_FRAME_A_Selected>auto</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Number B frames</td>
        <td>
         <select name="NUM_B_FRAMES">
          <option $B_FRAME_0_Selected>0</option>
          <option $B_FRAME_1_Selected>1</option>
          <option $B_FRAME_2_Selected>2</option>
          <option $B_FRAME_A_Selected>auto</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>MPEG4 Profile</td>
        <td>
         <select name="MPEG4_PROFILE">
          <option $PROFILE_B_Selected>Base</option>
          <option $PROFILE_M_Selected>Main</option>
          <option $PROFILE_H_Selected>High</option>
          <option $PROFILE_A_Selected>auto</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>MPEG4 Level</td>
        <td>
         <select name="MPEG4_LEVEL">
          <option $LEVEL_12_Selected>1.2</option>
          <option $LEVEL_20_Selected>2.0</option>
          <option $LEVEL_21_Selected>2.1</option>
          <option $LEVEL_22_Selected>2.2</option>
          <option $LEVEL_30_Selected>3.0</option>
          <option $LEVEL_31_Selected>3.1</option>
          <option $LEVEL_32_Selected>3.2</option>
          <option $LEVEL_40_Selected>4.0</option>
          <option $LEVEL_41_Selected>4.1</option>
          <option $LEVEL_A_Selected>auto</option>
         </select>
        </td>
       </tr>
       <!--
       <tr>
        <td>Stream Type</td>
        <td>
         <select name="STREAM_TYPE">
          <option $TS_Selected>Transport</option>
          <option $MP4_Selected>MP4</option>
         </select>
        </td>
       </tr>
       -->
      </table>
      </td>
      <td>
      <table width=300 class=props border="1" cellpadding="2" cellspacing="1">
       <tr align=left><th colSpan="2">Control</th></tr>
       <tr align="left">
        <td>Error Handling<br>(IP output only)</td>
        <td>
         <select name="ENCODER_ACTION">
          <option $EncAction_Restart_Selected>Restart</option>
          <option $EncAction_Reboot_Selected>Reboot</option>
         </select>
        </td>
       </tr>
!
    if [ $HAS_SDI != false ] ; then
        cat <<!
       <tr>
        <td>Resync SDI</td>
        <td>
         <select name="RESYNC_SDI">
          <option $RESYNC_SDI_ON_Selected>Yes</option>
          <option $RESYNC_SDI_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
!
       if [ $HAS_HDMI = true ] ; then
           cat <<!
       <tr>
        <td>Resync HDMI</td>
        <td>
         <select name="RESYNC_HDMI">
          <option $RESYNC_HDMI_ON_Selected>Yes</option>
          <option $RESYNC_HDMI_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
!
       fi
    fi
    cat <<!
       <tr>
        <td>Dynamic Bitrate [1]</td>
        <td>
         <select name="DYNAMIC_BITRATE">
          <option $DYNAMIC_BITRATE_ON_Selected>Yes</option>
          <option $DYNAMIC_BITRATE_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
       <tr>
        <td colSpan="2" nowrap>[1] Experimental</td>
       </tr>
       <tr align=left><th colSpan="2">Output</th></tr>
       <tr align="left">
        <td>Program Number</td>
        <td><input name="PROGRAM" size="8" maxlength="8" value="$PROGRAM" type="text"></td>
       </tr>
       <tr align="left">
        <td>PMT PID</td>
        <td><input name="PMT_PID" size="8" maxlength="8" value="$PMT_PID" type="text"></td>
       </tr>
       <tr align="left">
        <td>Video PID</td>
        <td><input name="VIDEO_PID" size="8" maxlength="8" value="$VIDEO_PID" type="text"></td>
       </tr>
       <tr align="left">
        <td>Audio 1/2 PID</td>
        <td><input name="AUDIO_PID" size="8" maxlength="8" value="$AUDIO_PID" type="text"></td>
       </tr>
       <tr align="left">
        <td>Audio 3/4 PID</td>
        <td><input name="AUDIO_PID2" size="8" maxlength="8" value="$AUDIO_PID2" type="text"></td>
       </tr>
       <tr align="left">
        <td>PCR PID<br>(usually=Video PID)</td>
        <td><input name="PCR_PID" size="8" maxlength="8" value="$PCR_PID" type="text"></td>
       </tr>
       <tr align="left">
        <td>Audio 1/2 Lang</td>
        <td><input name="AUDIO_LANG_DESC1" size="8" maxlength="8" value="$AUDIO_LANG_DESC1" type="text"></td>
       </tr>
       <tr align="left">
        <td>Audio 3/4 Lang</td>
        <td><input name="AUDIO_LANG_DESC2" size="8" maxlength="8" value="$AUDIO_LANG_DESC2" type="text"></td>
       </tr>
       <tr align="left">
        <td nowrap>Service Name [2]</td>
        <td><input name="SERVICE_NAME" size="20" maxlength="40" value="$SERVICE_NAME" type="text"></td>
       </tr>
       <tr align="left">
        <td nowrap>Service Provider [2]</td>
        <td><input name="SERVICE_PROVIDER" size="20" maxlength="40" value="$SERVICE_PROVIDER" type="text"></td>
       </tr>
       <tr>
        <td colSpan="2" nowrap>[2] Only for Network output</td>
       </tr>
       <tr align=left><th colSpan="2">File Output</th></tr>
       <tr align="left">
        <td>Name</td>
        <td><input name="FILE_NAME" size="20" maxlength="40" value="$FILE_NAME" type="text"></td>
       </tr>
       <tr>
        <td>Max Size (Bytes)</td>
        <td>
         <select name="FILE_SIZE">
          <option $FILE_SIZE_0_Selected>Unlimited</option>
          <option $FILE_SIZE_50M_Selected>50M</option>
          <option $FILE_SIZE_100M_Selected>100M</option>
          <option $FILE_SIZE_250M_Selected>250M</option>
          <option $FILE_SIZE_500M_Selected>500M</option>
          <option $FILE_SIZE_1G_Selected>1G</option>
          <option $FILE_SIZE_2G_Selected>2G</option>
          <option $FILE_SIZE_3G_Selected>3G</option>
          <option $FILE_SIZE_4G_Selected>4G</option>
          <option $FILE_SIZE_6G _Selected>6G</option>
          <option $FILE_SIZE_8G_Selected>8G</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Overwrite</td>
        <td>
         <input type=radio name="FILE_OVERWRITE" value="No" $FM0_CHECKED >No
         <input type=radio name="FILE_OVERWRITE" value="Yes" $FM1_CHECKED >Yes
        </td>
       </tr>
      </table>
      </td>
     </tr>
    </table>
    </div>

    <!-- Advanced Networking Parameters -->
    <div id="content3" class="tabcontent" style="display:none;">
      <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
       <tr align=left><th colSpan="2">Network</th></tr>
       <tr align="left">
        <td>TS packets per IP packet</td>
        <td>
         <select name="NUM_TS_PKTS_PER_IP_PKT">
          <option $TS_PKTS_1_Selected>1</option>
          <option $TS_PKTS_2_Selected>2</option>
          <option $TS_PKTS_3_Selected>3</option>
          <option $TS_PKTS_4_Selected>4</option>
          <option $TS_PKTS_5_Selected>5</option>
          <option $TS_PKTS_6_Selected>6</option>
          <option $TS_PKTS_7_Selected>7</option>
         </select>
        </td>
       </tr>
       <tr>
         <td>Use Bandwidth Ceiling</td>
         <td><input type=radio name="USE_CEILING" value="1" $CEILING1_CHECKED >Yes
             <input type=radio name="USE_CEILING" value="0" $CEILING0_CHECKED >No
         </td>
       </tr>
<!--
       <tr align="left">
        <td>Unicast TTL (Time-To-Live)</td>
        <td><input name="UNI_TTL" size="8" maxlength="8" value="$UNI_TTL" type="text"></td>
       </tr>
       <tr align="left">
        <td>Multicast TTL (Time-To-Live)</td>
        <td><input name="M_TTL" size="8" maxlength="8" value="$M_TTL" type="text"></td>
       </tr>
-->
       <tr align="left">
        <td>TOS (Type-of-Service)</td>
        <td><input name="TOS" size="8" maxlength="8" value="$TOS" type="text"></td>
       </tr>
       <tr>
        <td>Send SAP announcement</td>
        <td>
         <input type=radio name="DO_SDP" value="1" $SDP1_CHECKED >Yes
         <input type=radio name="DO_SDP" value="0" $SDP0_CHECKED >No
        </td>
       </tr>
       <tr align="left">
        <td>SAP Session Name</td>
        <td><input name="SDP_NAME" size="32" maxlength="15" value="$SDP_NAME" type="text"></td>
       </tr>
       <tr align="left">
        <td>Insert Metadata</td>
        <td><input type=radio name="DO_METADATA" value="1" $METADATA1_CHECKED >Yes
            <input type=radio name="DO_METADATA" value="0" $METADATA0_CHECKED >No
        </td>
       </tr>
       <tr align="left">
        <td>Metadata UDP Port</td>
        <td><input name="METADATA_PORT" size="8" maxlength="8" value="$METADATA_PORT" type="text"></td>
       </tr>
       <tr align="left">
        <td>Sequence 0XFFFF work around</td>
        <td><input type=radio name="SEQ_0XFFFF_HACK" value="yes" $SEQ_0XFFFF_HACK_YES_CHECKED >Yes
            <input type=radio name="SEQ_0XFFFF_HACK" value="no" $SEQ_0XFFFF_HACK_NO_CHECKED >No
        </td>
       </tr>
!
    if [ "$HAS_BOND" = 1 ] ; then
        cat <<!
       <tr align="left">
        <td>Bonding (generally off)</td>
        <td><input type=radio name="BOND_PORTS" value="true" $BOND_TRUE_CHECKED  onClick=verifyBond()>On
            <input type=radio name="BOND_PORTS" value="false" $BOND_FALSE_CHECKED  onClick=verifyBond()>Off
        </td>
       </tr>
       <tr align="left">
        <td>LAN1 Bond Pct</td>
        <td><input name="LAN1_PERCENT" size="3" maxlength="3" value="$LAN1_PERCENT" type="text" xx()>%</td>
       </tr>
!
    fi
    cat <<!
       <!--
       <tr align="left">
        <td>ARQ Buffers</td>
        <td>
         <select name="ARQ_TX_BUFS">
          <option $ARQ_TX_BUFS_1024_Selected>1024</option>
          <option $ARQ_TX_BUFS_2048_Selected>2048</option>
          <option $ARQ_TX_BUFS_4096_Selected>4096</option>
         </select>
        </td>
       </tr>
       -->
!
    if [ $HAS_ARQ = 1 ] ; then
        cat <<!
       <tr align=left><th colSpan="2">Optionally output stream to another destination as a UDP stream</th></tr>
       <tr align="left">
        <td>Destination IP Address</td>
        <td><input name="ALT_DEST_IPADDR" size="16" maxlength="15" value="$ALT_DEST_IPADDR" type="text"></td>
       </tr>
       <tr align="left">
        <td>Destination UDP Port</td>
        <td><input name="ALT_DEST_PORT" size="16" maxlength="15" value="$ALT_DEST_PORT" type="text"></td>
       </tr>
!
    fi
    if [ $HAS_FEC = 1 ] ; then
        cat <<!
       <!-- Error Correction Parameters -->
       <tr align=left><th colSpan="2">ProMPEG FEC</th></tr>
       <tr align="left">
        <td>Columns</td>
        <td><input name="FEC_COLUMNS" size="4" maxlength="4" value="$FEC_COLUMNS" type="text"></td>
       </tr>
       <tr align="left">
        <td>Rows</td>
        <td><input name="FEC_ROWS" size="4" maxlength="4" value="$FEC_ROWS" type="text"></td>
       </tr>
       <tr>
        <td>FEC Type</td>
        <td>
         <select name="FEC_TYPE">
          <option $FEC_CO_Selected>Column Only</option>
          <option $FEC_RC_Selected>Row + Column</option>
         </select>
        </td>
       </tr>
!
    fi
    cat <<!

      </table>

    </div>

 <br>
 <input id="btn_sav" value="Save" name="save" type="button" onclick="verify(1)">
 <input id="btn_sav_as" value="Save As" name="save_as" type="button" onclick="verify(2)">
 <input value="Cancel" type="button" onClick="location.href='/cgi-bin/encoder_profiles.cgi'">
 </form>
</body>
</html>
!

else

    [ "$PROFILE" = "" ] && PROFILE=/flash/qvidium/encoder/profile

    [ $NUM_TS_PKTS_PER_IP_PKT -gt 7 ] && NUM_TS_PKTS_PER_IP_PKT=7
    [ $NUM_TS_PKTS_PER_IP_PKT -lt 1 ] && NUM_TS_PKTS_PER_IP_PKT=1
    if [ "$TRANSPORT" = RTMP ] ; then
        NUM_TS_PKTS_PER_IP_PKT=7
        case $IPADDR_OR_HOSTNAME in
            *RTMP*|*rtmp*|*RTSP*|*rtsp*) true ;;
            *) IPADDR_OR_HOSTNAME=
               UDP_PORT=
               ;;
        esac
    elif [ "$TRANSPORT" = MSS ] ; then
        NUM_TS_PKTS_PER_IP_PKT=7
        case $IPADDR_OR_HOSTNAME in
            *http*|*HTTP*) true ;;
            *) IPADDR_OR_HOSTNAME=
               UDP_PORT=
               ;;
        esac
    elif [ "$TRANSPORT" = HLS ] ; then
        NUM_TS_PKTS_PER_IP_PKT=7
        IPADDR_OR_HOSTNAME=
        [ "$UDP_PORT" = "" ] && UDP_PORT="playlist"
    else
        [ "$UDP_PORT" = "" ] && UDP_PORT=10000
        [ $UDP_PORT -gt 65535 ] && UDP_PORT=10000
        [ $UDP_PORT -lt 0 ] && UDP_PORT=10000
        [ "$ARQ_PORT" = "" ] && ARQ_PORT=10000
        [ $ARQ_PORT -gt 65535 ] && ARQ_PORT=10000
        [ $ARQ_PORT -lt 0 ] && ARQ_PORT=10000
    fi

    [ $LATENCY = "" ] && LATENCY=1000
    [ $FEC_COLUMNS -gt 25 ] && FEC_COLUMNS=25
    [ $FEC_COLUMNS -lt 4 ] && FEC_COLUMNS=4
    [ $FEC_ROWS -gt 20 ] && FEC_ROWS=20
    [ $FEC_ROWS -lt 4 ] && FEC_ROWS=4

    [ "$UNI_TTL" = "" ] && UNI_TTL=128
    [ "$UNI_TTL" -lt 1 ] && UNI_TTL=1
    [ "$UNI_TTL" -gt 255 ] && UNI_TTL=255
    [ "$M_TTL" = "" ] && M_TTL=32
    [ "$M_TTL" -lt 1 ] && M_TTL=1
    [ "$M_TTL" -gt 255 ] && M_TTL=255

    case "$OUTPUT" in
        "File MP4"*) OUTPUT="File MP4" ;;
    esac
    [ "$TS_BITRATE" -gt 25000000 ] && TS_BITRATE=25000000
    [ "$SD_SDI_BITRATE" -gt 25000000 ] && SD_SDI_BITRATE=25000000
    [ $TS_BITRATE -lt 224000 ] && TS_BITRATE=224000
    [ $SD_SDI_BITRATE != 0 -a $SD_SDI_BITRATE -lt 224000 ] && SD_SDI_BITRATE=224000

    cat <<! > $PROFILE
NAME="$NAME"
ALT_DEST_PORT=$ALT_DEST_PORT
ALT_DEST_IPADDR=$ALT_DEST_IPADDR
CLOSED_CAPTION=$CLOSED_CAPTION
BOND_PORTS=$BOND_PORTS
LAN1_PERCENT=$LAN1_PERCENT
VIDEO_OUTPUT=$VIDEO_OUTPUT
FRAME_RATE=$FRAME_RATE
STREAM_TYPE=$STREAM_TYPE
TS_BITRATE=$TS_BITRATE
SD_SDI_BITRATE=$SD_SDI_BITRATE
DTS_DELAY_FROM_PCR=$DTS_DELAY_FROM_PCR
NUM_B_FRAMES=$NUM_B_FRAMES
NUM_P_FRAMES=$NUM_P_FRAMES
MPEG4_PROFILE=$MPEG4_PROFILE
MPEG4_LEVEL=$MPEG4_LEVEL
PROGRAM=$PROGRAM
FILE_NAME=$FILE_NAME
FILE_SIZE=$FILE_SIZE
FILE_OVERWRITE=$FILE_OVERWRITE
REMUX="$REMUX"
VIDEO_PID=$VIDEO_PID
AUDIO_PID=$AUDIO_PID
AUDIO_PID2=$AUDIO_PID2
PCR_PID=$PCR_PID
PMT_PID=$PMT_PID
STREAM_MODE="$STREAM_MODE"
ENC_TYPE="$ENC_TYPE"
STREAM_PASSWORD="$STREAM_PASSWORD"
AVIN_6DB_ATTN=$AVIN_6DB_ATTN
ANALOG_HDVIDEO=$ANALOG_HDVIDEO
RESYNC_SDI=$RESYNC_SDI
RESYNC_HDMI=$RESYNC_HDMI
DYNAMIC_BITRATE=$DYNAMIC_BITRATE
AUDIO_VIDEO="$AUDIO_VIDEO"
AUDIO_CHANNELS=$AUDIO_CHANNELS
AUDIO_BITRATE=$AUDIO_BITRATE
AUDIO_SAMPLE_RATE=$AUDIO_SAMPLE_RATE
AUDIO_ENCODING="$AUDIO_ENCODING"
VIDEO_ENCODING="$VIDEO_ENCODING"
VIDEO_INPUT=$VIDEO_INPUT
VIDEO_FILTER=$VIDEO_FILTER
SERVICE_NAME="$SERVICE_NAME"
SERVICE_PROVIDER="$SERVICE_PROVIDER"
ENCODER_ACTION=$ENCODER_ACTION
SD_PROGRESSIVE=$SD_PROGRESSIVE
SHARPNESS=$SHARPNESS
VIDEO_SD_RES="$VIDEO_SD_RES"
VIDEO_ASPECT=$VIDEO_ASPECT
AUDIO_LANG_DESC1=$AUDIO_LANG_DESC1
AUDIO_LANG_DESC2=$AUDIO_LANG_DESC2
AUDIO_FIXED_PES=$AUDIO_FIXED_PES
OUTPUT="$OUTPUT"
TRANSPORT="$TRANSPORT"
ENCRYPTION_PASSWORD="$ENCRYPTION_PASSWORD"
IPADDR_OR_HOSTNAME="$IPADDR_OR_HOSTNAME"
UDP_PORT="$UDP_PORT"
NUM_TS_PKTS_PER_IP_PKT=$NUM_TS_PKTS_PER_IP_PKT
USE_PACING=$USE_PACING
USE_CEILING=$USE_CEILING
ARQ_PORT=$ARQ_PORT
ARQ_TX_BUFS=$ARQ_TX_BUFS
DO_METADATA=$DO_METADATA
METADATA_PORT=$METADATA_PORT
SEQ_0XFFFF_HACK=$SEQ_0XFFFF_HACK
DO_SDP=$DO_SDP
SDP_NAME="$SDP_NAME"
FEC_COLUMNS=$FEC_COLUMNS
FEC_ROWS=$FEC_ROWS
FEC_TYPE="$FEC_TYPE"
UNI_TTL=$UNI_TTL
M_TTL=$M_TTL
TOS=$TOS
LATENCY=$LATENCY
ZIXI_LOGLEVEL=$ZIXI_LOGLEVEL
ADAPTATION=$ADAPTATION
!

    cat <<!
<html>
<head>
  <title>Profile Status</title>
  <link href="/style.css" type="text/css" rel="stylesheet">
</head>
<body>
 <h3>Profile Status</h3>
 OK. <br><br>Press the "Profiles" option to update view.
</body>
</html>
!

fi
