#!/bin/sh

# Copyright (C) 2004-2016 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

RC_ZIXI=/disk/zixi/rc.zixi
[ -f $RC_ZIXI ] && sh $RC_ZIXI

ZIXI_CONF=/flash/qvidium/zixi.conf

if [ "$QUERY_STRING" != "" ]; then
    eval `./cgiparse "$QUERY_STRING"`
fi

if [ "$start" != "" ] ; then
    msg=`sh /disk/zixi/bin/zixi_stop`
    msg=`sh /disk/zixi/bin/zixi_start`
elif [ "$stop" != "" ] ; then
    msg=`sh /disk/zixi/bin/zixi_stop`
elif [ "$update" != "" ] ; then

    [ "$UDP_PORT" = "" ] && UDP_PORT=1234
    [ "$ENTRY1_ENABLE" = "" ] && ENTRY1_ENABLE=0
    [ "$ENTRY2_ENABLE" = "" ] && ENTRY2_ENABLE=0

    cat << EOT > $ZIXI_CONF
UDP_PORT=$UDP_PORT
ENTRY1_ENABLE=$ENTRY1_ENABLE
ENTRY1_URI="$ENTRY1_URI"
ENTRY1_STREAMNAME="$ENTRY1_STREAMNAME"
ENTRY2_ENABLE=$ENTRY2_ENABLE
ENTRY2_URI="$ENTRY2_URI"
ENTRY2_STREAMNAME="$ENTRY2_STREAMNAME"
EOT
    msg='Encoder output configuration update. Please start to take affect'
else
    msg='Invalid Encoder Output Action'
fi

cat << EOT
<html>
<head>
 <title>Encoder Output Results</title>
 <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
 <h3>Zixi Output Results</h3>
 $msg
</body>
</html>
EOT
